﻿using System.Collections.Generic;
using System.Diagnostics.Contracts;

namespace ContractGenerator
{
    public class LoaderFiles
    {
        /// <summary>
        /// The user-supplied DECLS and DTRACE files; DECLS file are before DTRACE files.
        /// Trace files are generated by running Celeriac.
        /// </summary>
        public ICollection<string> TraceFiles { get; set; }

        /// <summary>
        /// The user-supplied invariants file. An invariant file is generated by running Daikon main.
        /// </summary>
        public string InvariantFile { get; set; }

        /// <summary>
        /// The user-supplied contracts file. A contract file is generated by running Daikon print invariants on an invariants file.
        /// </summary>
        public string ContractFile { get; set; }

        public LoaderFiles()
        {
            TraceFiles = new List<string>();
            InvariantFile = string.Empty;
            ContractFile = string.Empty;
        }
    }

    /// <summary>
    /// Configuration options for loading contracts into the inserter interface.
    /// If neither an invariant file or trace files (DECLS and DTRACE files) is
    /// set, then the inserter should generate the contracts using Celeriac.
    /// </summary>
    public class LoaderConfiguration
    {
        /// <summary>
        /// Path to the Celeriac executable
        /// </summary>
        public string CeleriacExecutablePath { get; private set; }

        /// <summary>
        /// The directory of the executable to be instrumented.
        /// </summary>
        public string ExecutableDirectory { get; private set; }

        /// <summary>
        /// The path to the executable to be instrumented.
        /// </summary>
        public string ExecutablePath { get; private set; }

        /// <summary>
        /// The project directory of the project being annotated.
        /// </summary>
        public string ProjectDirectory { get; private set; }

        /// <summary>
        /// The invariant, contract, or trace files to use. 
        /// </summary>
        public LoaderFiles Files { get; private set; }

        /// <summary>
        /// The auto-generated splitter files passed to Daikon main.
        /// </summary>
        public ICollection<string> SplitterFiles { get; private set; }

        /// <summary>
        /// Whether or not to run SEAL purity analysis. The default is true.
        /// </summary>
        public bool RunSealPurityAnalysis { get; private set; }

        /// <summary>
        /// <c>True</c> if trace files, a contract file, or invariant file is provided.
        /// </summary>
        public bool SkipCeleriac
        {
            get
            {
                return Files.TraceFiles.Count > 0 || !string.IsNullOrEmpty(Files.InvariantFile) || !string.IsNullOrEmpty(Files.ContractFile);
            }
        }

        /// <summary>
        /// <c>True</c> if an invariant or contract file is provided.
        /// </summary>
        public bool SkipDaikonMain
        {
            get
            {
                return !string.IsNullOrEmpty(Files.InvariantFile) || !string.IsNullOrEmpty(Files.ContractFile);
            }
        }

        /// <summary>
        /// <c>True</c> if a contracts file is provided.
        /// </summary>
        public bool SkipDaikonPrintInvariants
        {
            get
            {
                return !string.IsNullOrEmpty(Files.ContractFile);
            }
        }

        public LoaderConfiguration(LoaderFiles loaderFiles, string celeriacExecutablePath, string projectDirectory, string executableDirectory, string executablePath)
        {
            Contract.Requires(loaderFiles != null);
            // TODO: Throw exceptions if these files do not exist? Or do it earlier.

            RunSealPurityAnalysis = true;
            CeleriacExecutablePath = celeriacExecutablePath;
            ProjectDirectory = projectDirectory;
            ExecutableDirectory = executableDirectory;
            ExecutablePath = executablePath;
            Files = loaderFiles;
            SplitterFiles = new List<string>();
        }
    }
}
